<?php
//---------------------------------------------------------------------
// [do/ce | codebreaker] (c)2024 cxx05610(zenmaido)
// 個人の範囲内で使用できますが、商用利用、再配布はご遠慮ください
//---------------------------------------------------------------------
if(empty($_COOKIE['doce_cb_code'])){
	$code=setcode();
	setcookie('doce_cb_code',$code,time()+60*60*24*7);
}else{
	$code=$_COOKIE['doce_cb_code'];
}
$answer='';
if($_SERVER['REQUEST_METHOD']==='POST'){
	if($_POST['mode']==='judge'){
		$try='';
		for($i=0;$i<6;$i++){
			$key[$i]=$_POST['key_'.$i];
			$try.=$key[$i];
		}
		$answer=codebreak($code,$try);
	}elseif($_POST['mode']==='reset'){
		reset_game();
	}
}else{
	for($i=0;$i<6;$i++){
		$key[$i]=0;
	}
}
function setcode(){
	$val='';
	$num=range(0,9);
	shuffle($num);
	for($i=0;$i<6;$i++){
		$val.=$num[$i];
	}
	return $val;
}
function codebreak($code,$try){
	if(mb_strlen($try)===6){
		if($code===$try){
			//合致した
			setcookie('doce_cb_flg','1',time()+60*60*24*7);
			return '<b>//codebreak// ' .$code. '</b> - try new code!';
		}else{
			//はずれ、ヒット&ブロー判定
			$arr1=str_split($code);
			$arr2=str_split($try);
			$hit=$blow=0;
			foreach($arr1 as $k=>$val){
				if($val===$arr2[$k]){
					$hit++;
				}elseif(in_array($val,$arr2)){
					$blow++;
				}
			}
			return '<b>//error//</b> hit:' .$hit. ' blow:'.$blow;
		}
	}else{
		return '<b>//error//</b> invalid code';
	}
}
function reset_game(){
	setcookie('doce_cb_code','',time()-3600);
	setcookie('doce_cb_flg','',time()-3600);
	header('Location: '.'./cb.php');
}
?>
<!DOCTYPE html>
<html lang="ja">
<head>
	<meta charset="UTF-8">
	<meta name="viewport" content="width=device-width,initial-scale=1">
	<title>codebreaker</title>
</head>
<body>
<header>
	<h1>codebreaker</h1>
</header>
<main>
<section>
<article>
<p>▼ input 6 digits code.</p>
<form method="POST">
<input type="hidden" name="mode" value="judge">
<?php for($i=0;$i<6;$i++): ?>
<select name="key_<?php echo $i; ?>" class="judge">
	<option selected><?php echo $key[$i]; ?></option>
	<hr />
	<?php for($j=0;$j<10;$j++): ?>
		<option><?php echo $j; ?></option>
	<?php endfor; ?>
</select>&nbsp;
<?php endfor; ?>
<button type="submit" class="judge">judge!</button>
</form>
<p><?php echo $answer; ?></p>
<form method="POST">
<input type="hidden" name="mode" value="reset">
<button type="submit" class="judge">try new code</button>
</form>
</article>
</section>
</main>
<footer style="padding-top:24px;">
	<address>[<a href="../index.php">do/ce | codebreaker</a>] &copy;2025 zenmaido</address>
</footer>
</body>
</html>